# coding: utf-8

"""
    Fox API

     Warning: Please add a custom user agent header to your requests. This would help us fighting against DDoS attacks in future, while keeping your application's access to the API. In future, this may be a mandatory requirement.  To reduce the system load, the API endpoints are rate limited. The default limit is 30 requests per minute. Contact admin@orangefox.tech if you need a higher limit.  The requests may be logged for analytics and development purposes. 

    The version of the OpenAPI document: 5.2.2
    Contact: admin@orangefox.tech
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DeviceUpdateBody(BaseModel):
    """
    DeviceUpdateBody
    """ # noqa: E501
    oem_name: Optional[StrictStr] = None
    codenames: Optional[List[StrictStr]] = None
    model_names: Optional[List[StrictStr]] = None
    supported: Optional[StrictBool] = None
    freezed: Optional[StrictBool] = None
    notes: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["oem_name", "codenames", "model_names", "supported", "freezed", "notes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeviceUpdateBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if oem_name (nullable) is None
        # and model_fields_set contains the field
        if self.oem_name is None and "oem_name" in self.model_fields_set:
            _dict['oem_name'] = None

        # set to None if codenames (nullable) is None
        # and model_fields_set contains the field
        if self.codenames is None and "codenames" in self.model_fields_set:
            _dict['codenames'] = None

        # set to None if model_names (nullable) is None
        # and model_fields_set contains the field
        if self.model_names is None and "model_names" in self.model_fields_set:
            _dict['model_names'] = None

        # set to None if supported (nullable) is None
        # and model_fields_set contains the field
        if self.supported is None and "supported" in self.model_fields_set:
            _dict['supported'] = None

        # set to None if freezed (nullable) is None
        # and model_fields_set contains the field
        if self.freezed is None and "freezed" in self.model_fields_set:
            _dict['freezed'] = None

        # set to None if notes (nullable) is None
        # and model_fields_set contains the field
        if self.notes is None and "notes" in self.model_fields_set:
            _dict['notes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeviceUpdateBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "oem_name": obj.get("oem_name"),
            "codenames": obj.get("codenames"),
            "model_names": obj.get("model_names"),
            "supported": obj.get("supported"),
            "freezed": obj.get("freezed"),
            "notes": obj.get("notes")
        })
        return _obj


